<?php
declare(strict_types=1);
/**
 * Plugin Name: Catequil Plugin
 * Description: Integracija s Catequil WMS-om
 * Version: 0.1.0
 */
namespace Catequil\Plugin;

use Laminas\ServiceManager\ServiceManager;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\ContainerInterface;
use Psr\Container\NotFoundExceptionInterface;

use function add_action;

const LOAD_MODULES = [
    Handler\OrderHandler::class,
];

/**
 * @return ContainerInterface
 */
function get_container(): ContainerInterface
{
    global $container;

    if (!$container instanceof ContainerInterface) {
        $config = (new ConfigProvider())();
        $config['dependencies']['services']['config'] = $config;
        $container = new ServiceManager($config['dependencies']);
    }

    return $container;
}

add_action('plugins_loaded', /**
 * @throws ContainerExceptionInterface
 * @throws NotFoundExceptionInterface
 */ function () {
    $container = get_container();

    foreach (LOAD_MODULES as $module) {
        $container->get($module);
    }
});
