<?php
declare(strict_types=1);

namespace Catequil\Plugin;

/**
 * Class ConfigProvider
 *
 * @package Catequil\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-plugin
 */
final class ConfigProvider
{
    public function __invoke(): array
    {
        return [
            'catequil' => [
                'base_uri' => 'https://catequil.net/api/',
                'shipping_priorities' => [
                    'local_pickup' => 100,
                ],
                'username' => '',
                'password' => '',
                'webshop' => '',
            ],

            'dependencies' => $this->getDependencies(),
        ];
    }

    public function getDependencies(): array
    {
        return [
            'factories' => [
                'CatequilHttp' => Container\HttpClientFactory::class,
                Configuration::class => Container\ConfigurationFactory::class,
                Gateway\PackageGateway::class => Container\AbstractGatewayFactory::class,
                Handler\OrderHandler::class => Handler\OrderHandlerFactory::class,
            ],
        ];
    }
}
