<?php
declare(strict_types=1);

namespace Catequil\Plugin;

use function array_merge;

/**
 * Class Configuration
 *
 * @package Catequil\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-plugin
 */
final class Configuration
{
    private array $config = [
        'base_uri' => 'https://catequil.net/api/',
        'username' => '',
        'password' => '',
        'webshop'  => '',
    ];

    /**
     * @param array $config
     */
    public function __construct(array $config)
    {
        $this->config = array_merge($this->config, $config);
    }

    public function getPriority(string $shipping_method): int
    {
        return $this->config['shipping_priorities'][$shipping_method] ?? 0;
    }

    /**
     * @return string
     */
    public function getBaseUri(): string
    {
        return $this->config['base_uri'];
    }

    /**
     * @return string
     */
    public function getUsername(): string
    {
        return $this->config['username'];
    }

    /**
     * @return string
     */
    public function getPassword(): string
    {
        return $this->config['password'];
    }

    /**
     * @return string
     */
    public function getWebshop(): string
    {
        return $this->config['webshop'];
    }
}
