<?php
declare(strict_types=1);

namespace Catequil\Plugin\Gateway;

use Catequil\Plugin\Configuration;
use GuzzleHttp\Client;

/**
 * Class AbstractGateway
 *
 * @package Catequil\Plugin\Gateway
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-plugin
 */
abstract class AbstractGateway
{
    protected Configuration $config;
    protected Client $http;

    /**
     * @param Configuration $config
     * @param Client $http
     */
    public function __construct(Configuration $config, Client $http)
    {
        $this->config = $config;
        $this->http   = $http;
    }
}
