<?php
declare(strict_types=1);

namespace Catequil\Plugin\Handler;

use Catequil\Plugin\Gateway\PackageGateway;
use Laminas\ServiceManager\Factory\FactoryInterface;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\ContainerInterface;
use Psr\Container\NotFoundExceptionInterface;

/**
 * Class OrderHandlerFactory
 *
 * @package Catequil\Plugin\Handler
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-plugin
 */
final class OrderHandlerFactory implements FactoryInterface
{
    /**
     * @param ContainerInterface $container
     * @param $requestedName
     * @param array|null $options
     *
     * @return OrderHandler
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container, $requestedName, ?array $options = null): OrderHandler
    {
        return new OrderHandler(
            $container->get(PackageGateway::class)
        );
    }
}
